#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int _g = validator.group() == "" ? -1 : atoi(validator.group().c_str());

    int n = inf.readInt(1, 100000, "n");
    inf.readSpace();
    int q = inf.readInt(1, 100000, "q");
    inf.readEoln();
    if (_g == 3) {
        ensuref(n <= 200, "group 3 has n = %d > 200", n);
        ensuref(q <= 200, "group 3 has q = %d > 200", q);
    } else if (_g == 5) {
        ensuref(n <= 2000, "group 3 has n = %d > 2000", n);
        ensuref(q <= 2000, "group 3 has q = %d > 2000", q);
    }

    auto h = inf.readInts(n, 1, 1000000000, "h");
    inf.readEoln();
    if (_g == 1 || _g == 2) {
        for (int i = 1; i < n; i++) {
            if (_g == 1) ensuref(h[i - 1] == h[i], "group 1 has different h[%d] != h[%d]", i, i + 1);
            else ensuref(h[i - 1] <= h[i], "group 2 has h[%d] > h[%d]", i, i + 1);
        }
    }

    vector<bool> marked(n, false);
    for (int i = 0; i < q; i++) {
        int l = inf.readInt(1, n, format("l_%d", i + 1)) - 1;
        inf.readSpace();
        int r = inf.readInt(1, n, format("r_%d", i + 1)) - 1;
        inf.readSpace();
        inf.readInt(0, 1000000000, format("f_%d", i + 1));
        inf.readEoln();

        ensuref(l <= r, "l = %d > r = %d in request %d", l, r, i + 1);
        if (_g == 4) ensuref(r - l <= 10, "group 4 has r - l = %d > 10 on request %d", r - l, i + 1);
        if (_g == 1 || _g == 2) {
            for (int t = l; t <= r; t++) {
                ensuref(!marked[t], "group %d has intersecting request %d", _g, i + 1);
                marked[t] = true;
            }
        }
    }

    inf.readEof();

}